# Reference
<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

**Functions**

* [`includable`](#includable): Test if a puppet class file exists and can be included

## Functions

### includable

Type: Ruby 4.x API

Function to detect whether it is possible to include a given puppet class or not based on whether
the class file exists. The intended usage of this is to allow lazy creation of role classes:

The reason for this is that Puppet deployers may want to assign roles to particular nodes without
_immediately_ having to create the associated role class. This removes the need for up-front
work creating role classes that are _TODO_ and the need to regenerate certificates once a suitable
role class becomes available.

Function is environment aware. There
is an undocumented private API for puppet which could be used to hook into Puppet internals and test
for class existance, however this API is subject to change without notice and this would entirely
break classification if used as the example above suggests. Instead, we convert the class name into
a string and attempt to match a regular expression defining the class inside it. If this matches the
intention of the user was _probably_ to write a class, although we make no claims as to its validity
and subsequent inclusion will fail if there are syntax errors.

#### `includable(String $classname)`

Function to detect whether it is possible to include a given puppet class or not based on whether
the class file exists. The intended usage of this is to allow lazy creation of role classes:

The reason for this is that Puppet deployers may want to assign roles to particular nodes without
_immediately_ having to create the associated role class. This removes the need for up-front
work creating role classes that are _TODO_ and the need to regenerate certificates once a suitable
role class becomes available.

Function is environment aware. There
is an undocumented private API for puppet which could be used to hook into Puppet internals and test
for class existance, however this API is subject to change without notice and this would entirely
break classification if used as the example above suggests. Instead, we convert the class name into
a string and attempt to match a regular expression defining the class inside it. If this matches the
intention of the user was _probably_ to write a class, although we make no claims as to its validity
and subsequent inclusion will fail if there are syntax errors.

Returns: `Any` true if `include classname` should succeed, otherwise false if the class is missing from
the filesystem

##### `classname`

Data type: `String`

Name of the class to test for incudability (existance as a file on the master)

